diff --git a/game/core/src/main/java/net/minecraft/core/net/packet/PacketMessage.java b/game/core/src/main/java/net/minecraft/core/net/packet/PacketMessage.java
new file mode 100644
index 000000000..341f31044
--- /dev/null
+++ b/game/core/src/main/java/net/minecraft/core/net/packet/PacketMessage.java
@@ -0,0 +1,86 @@
+package net.minecraft.core.net.packet;
+
+import net.minecraft.core.net.command.TextFormatting;
+import net.minecraft.core.net.handler.PacketHandler;
+import net.minecraft.core.util.helper.AES;
+
+import java.io.*;
+import java.security.Key;
+
+import org.jetbrains.annotations.Nullable;
+
+public class PacketMessage extends Packet {
+	
+	public static final String ENCRYPTION_ERROR_MESSAGE = "This crash is caused by outdated Java, please update to 8u161 or newer! If your Java version is out of date due to a technical requirement, please add the JCE Unlimited Strength Jurisdiction Policy Files to your installation. https://www.oracle.com/java/technologies/javase-jce-all-downloads.html";
+
+	public static final byte TYPE_CHAT = 0;
+	public static final byte TYPE_STATUS = 1;
+	private static final byte MASK_FORMATTED = (byte)0b1000_0000;
+
+	/**
+	 * server-side should not try to use this
+	 */
+    public @Nullable TextFormatting.Base format;
+	public String message;
+	public byte type;
+	public boolean encrypted;
+
+	public PacketMessage() {}
+
+	public PacketMessage(String string) {
+		this(string, TYPE_CHAT, null);
+	}
+
+	public PacketMessage(String string, Key key) {
+		this(string, TYPE_CHAT, key);
+	}
+	
+	public PacketMessage(String string, byte type, Key key) {
+		this(null, string, type, key);
+	}
+
+	public PacketMessage(@Nullable TextFormatting.Base format, String string, byte type, Key key) {
+		if(string.length() > 512) string = string.substring(0, 512);
+
+		if (key == null) {
+			this.message = string;
+		} else try {
+			this.message = AES.encrypt(string, key);
+		} catch (Exception e) {
+			throw new RuntimeException(ENCRYPTION_ERROR_MESSAGE, e);
+		}
+		this.encrypted = key != null;
+		this.format = format;
+		this.type = type;
+	}
+
+	@Override
+	public void read(DataInputStream in) throws IOException {
+		this.type = in.readByte();
+		final boolean formatted = ((type & MASK_FORMATTED) != 0);
+		this.type &= ~MASK_FORMATTED; 
+		this.encrypted = in.readBoolean();
+		this.format = (formatted)
+			? TextFormatting.Base.unpack(in.readShort())
+			: null;
+		this.message = readStringUTF8(in, MAX_MESSAGE_SIZE);
+	}
+
+	@Override
+	public void write(DataOutputStream out) throws IOException {
+		out.writeByte(this.type | ((this.format != null) ? MASK_FORMATTED : 0));
+		out.writeBoolean(this.encrypted);
+		if (this.format != null) out.writeShort(this.format.pack());
+		writeStringUTF8(this.message, out);
+	}
+
+	@Override
+	public void handlePacket(PacketHandler packetHandler) {
+		packetHandler.handleMessage(this);
+	}
+
+	@Override
+	public int getEstimatedSize() {
+		return message.length() + 1;
+	}
+}
diff --git a/game/core/src/main/java/net/minecraft/core/net/packet/PacketMessageTranslatable.java b/game/core/src/main/java/net/minecraft/core/net/packet/PacketMessageTranslatable.java
new file mode 100644
index 000000000..7dff81434
--- /dev/null
+++ b/game/core/src/main/java/net/minecraft/core/net/packet/PacketMessageTranslatable.java
@@ -0,0 +1,150 @@
+package net.minecraft.core.net.packet;
+
+import java.io.DataInputStream;
+import java.io.DataOutputStream;
+import java.io.IOException;
+import java.nio.charset.StandardCharsets;
+import java.util.ArrayList;
+
+import org.jetbrains.annotations.NotNull;
+import org.jetbrains.annotations.Nullable;
+
+import it.unimi.dsi.fastutil.objects.Object2ShortMap;
+import it.unimi.dsi.fastutil.objects.Object2ShortOpenHashMap;
+import net.minecraft.core.lang.Language;
+import net.minecraft.core.net.command.TextFormatting;
+import net.minecraft.core.net.handler.PacketHandler;
+
+public class PacketMessageTranslatable extends Packet {
+    public @Nullable TextFormatting.Base format;
+    public short key = -1;
+    public byte type;
+    public @NotNull String[] args;
+
+	public static final byte TYPE_CHAT = 0;
+	public static final byte TYPE_STATUS = 1;
+
+    public static final int MAX_ARG_LEN = 255;
+    public static final int MAX_ARG_COUNT = 4;
+	private static final byte MASK_FORMATTED = (byte)0b1000_0000;
+
+    public PacketMessageTranslatable() {}
+    public PacketMessageTranslatable(short key, @NotNull String... args) {
+        this(null, key, TYPE_CHAT, args);
+    }
+    public PacketMessageTranslatable(short key, byte type, @NotNull String... args) {
+        this(null, key, type, args);
+    }
+
+    public PacketMessageTranslatable(@Nullable TextFormatting.Base format, short key, @NotNull String... args) {
+        this(format, key, TYPE_CHAT, args);
+    }
+
+    public PacketMessageTranslatable(@Nullable TextFormatting.Base format, short key, byte type, @NotNull String... args) {
+        this.format = format;
+        this.key = key;
+        this.type = type;
+        this.args = args;
+    }
+
+    public PacketMessageTranslatable(@NotNull String key, @NotNull String... args) {
+        this(null, key, TYPE_CHAT, args);
+    }
+    public PacketMessageTranslatable(@NotNull String key, byte type, @NotNull String... args) {
+        this(null, key, type, args);
+    }
+
+    public PacketMessageTranslatable(@Nullable TextFormatting.Base format, @NotNull String key, @NotNull String... args) {
+        this(format, key, TYPE_CHAT, args);
+    }
+
+    public PacketMessageTranslatable(@Nullable TextFormatting.Base format, @NotNull String key, byte type, @NotNull String... args) {
+        this.format = format;
+        this.key = KEY2ID_MAP.getOrDefault(key, (short)-1);
+        assert this.key != -1;
+        this.type = type;
+        this.args = args;
+    }
+
+    @Override
+    public void write(DataOutputStream dos) throws IOException {
+        dos.writeShort(this.key);
+        dos.writeByte(this.type | ((this.format != null) ? MASK_FORMATTED : 0));
+        if (this.format != null) dos.writeShort(this.format.pack());
+
+        final int argc = Math.min(this.args.length, MAX_ARG_COUNT);
+        dos.writeByte(argc);
+
+        final var args = new byte[argc][];
+        for (int i = 0; i < argc; i++) {
+            args[i] = this.args[i].getBytes(StandardCharsets.UTF_8);
+        }
+
+        for (var arg : args) {
+            final int len = Math.min(arg.length, MAX_ARG_LEN);
+            dos.writeByte(len);
+        }
+        
+        for (var arg : args) {
+            final int len = Math.min(arg.length, MAX_ARG_LEN);
+            dos.write(arg, 0, len);
+        }
+    }
+
+    @Override
+    public void read(DataInputStream dis) throws IOException {
+        this.key = dis.readShort();
+        this.type = dis.readByte();
+        final boolean formatted = ((type & MASK_FORMATTED) != 0);
+        this.type &= ~MASK_FORMATTED; 
+        this.format = (formatted)
+            ? TextFormatting.Base.unpack(dis.readShort())
+            : null;
+
+        final int argc; {
+            final int read = Byte.toUnsignedInt(dis.readByte());
+            argc = Math.min(read, MAX_ARG_COUNT);
+        };
+
+        final var args = new byte[argc][];
+
+        for (int i = 0; i < argc; i++) {
+            final int len = Byte.toUnsignedInt(dis.readByte());
+            args[i] = new byte[len];
+        }
+        
+        for (int i = 0; i < argc; i++) {
+            dis.readFully(args[i]);
+        }
+
+        this.args = new String[argc];
+        for (int i = 0; i < argc; i++) {
+            this.args[i] = new String(args[i], StandardCharsets.UTF_8);
+        }
+    }
+
+    @Override
+    public void handlePacket(PacketHandler packetHandler) {
+        packetHandler.handleTranslatableMessage(this);
+    }
+    @Override
+    public int getEstimatedSize() {
+        return 2 + 1 + 1 + args.length + args.length * 16;
+    }
+
+    public static final @NotNull String @NotNull[] ID2KEY_MAP; 
+    static {
+        final var list = new ArrayList<String>();
+        final var entries = Language.Default.INSTANCE.getEntries();
+        for (final var key : entries.stringPropertyNames()) {
+            if (!key.startsWith("messages.")) continue;
+            list.add(key);
+        }
+        ID2KEY_MAP = list.toArray(String[]::new);
+    }
+
+    public static final @NotNull Object2ShortMap<@NotNull String> KEY2ID_MAP = new Object2ShortOpenHashMap<>(ID2KEY_MAP.length);    
+    static {
+        for (short i = 0; i < ID2KEY_MAP.length; i++) KEY2ID_MAP.put(ID2KEY_MAP[i], i);
+    }
+}
diff --git a/game/core/src/main/java/net/minecraft/core/util/helper/Direction.java b/game/core/src/main/java/net/minecraft/core/util/helper/Direction.java
index ea3aacaa6..2ad48ff04 100644
--- a/game/core/src/main/java/net/minecraft/core/util/helper/Direction.java
+++ b/game/core/src/main/java/net/minecraft/core/util/helper/Direction.java
@@ -108,17 +108,6 @@ public enum Direction {
         };
     }
 
-    @Deprecated
-    public int legacyHorizontalIndex() {
-        return switch (this) {
-            default -> 0;
-            case NORTH -> 0;
-            case EAST -> 1;
-            case SOUTH -> 2;
-            case WEST -> 3;
-        };
-    }
-
     // Friends:
     // ============================
 
diff --git a/game/core/src/main/java/net/minecraft/core/world/World.java b/game/core/src/main/java/net/minecraft/core/world/World.java
index c3968a005..ad34e9345 100644
--- a/game/core/src/main/java/net/minecraft/core/world/World.java
+++ b/game/core/src/main/java/net/minecraft/core/world/World.java
@@ -28,6 +28,7 @@ import net.minecraft.core.enums.EnumBlockSoundEffectType;
 import net.minecraft.core.enums.LightLayer;
 import net.minecraft.core.item.ItemStack;
 import net.minecraft.core.net.command.CommandManager;
+import net.minecraft.core.net.command.TextFormatting;
 import net.minecraft.core.sound.BlockSound;
 import net.minecraft.core.sound.SoundCategory;
 import net.minecraft.core.util.debug.Debug;
@@ -3001,8 +3002,24 @@ public abstract class World implements MutableWorldSource {
     }
 
     public void sendGlobalMessage(final String message) {
+        this.sendGlobalMessage(null, message);
+    }
+
+    public void sendGlobalMessageTranslated(final @NotNull String key, final @NotNull String... args) {
+        this.sendGlobalMessageTranslated(null, key, args);
+    }
+
+    public void sendGlobalMessage(@Nullable TextFormatting.Base format, final String message) {
+        for (final Player player : this.players) {
+            player.sendMessage(format, message);
+        }
+    }
+
+    public void sendGlobalMessageTranslated(@Nullable TextFormatting.Base format, 
+        final @NotNull String key, final @NotNull String... args
+    ) {
         for (final Player player : this.players) {
-            player.sendMessage(message);
+            player.sendMessageTranslated(format, key, args);
         }
     }
 
diff --git a/game/core/src/main/java/net/minecraft/core/world/save/ISaveConverter.java b/game/core/src/main/java/net/minecraft/core/world/save/ISaveConverter.java
index 9253bdb4d..84e673189 100644
--- a/game/core/src/main/java/net/minecraft/core/world/save/ISaveConverter.java
+++ b/game/core/src/main/java/net/minecraft/core/world/save/ISaveConverter.java
@@ -2,6 +2,7 @@ package net.minecraft.core.world.save;
 
 import com.mojang.nbt.tags.CompoundTag;
 import net.minecraft.core.world.ProgressListener;
+import org.jetbrains.annotations.NotNull;
 
 import java.io.File;
 
@@ -28,5 +29,5 @@ public interface ISaveConverter
      * @param saveDirName The name of the directory containing the specific save to convert.
      * @param progress A progress indicator for the conversion.
      */
-    void convertSave(CompoundTag levelData, File savesDir, String saveDirName, ProgressListener progress);
+    void convertSave(@NotNull CompoundTag levelData, @NotNull File savesDir, @NotNull String saveDirName, @NotNull ProgressListener progress);
 }
diff --git a/game/core/src/main/java/net/minecraft/core/world/save/SaveConverters.java b/game/core/src/main/java/net/minecraft/core/world/save/SaveConverters.java
index 0090b043a..5e483f259 100644
--- a/game/core/src/main/java/net/minecraft/core/world/save/SaveConverters.java
+++ b/game/core/src/main/java/net/minecraft/core/world/save/SaveConverters.java
@@ -2,6 +2,7 @@ package net.minecraft.core.world.save;
 
 import net.minecraft.core.world.save.conversion.SaveConverter19132To19133;
 import net.minecraft.core.world.save.conversion.SaveConverter19133To19134;
+import net.minecraft.core.world.save.conversion.SaveConverter19134To19135;
 import net.minecraft.core.world.save.conversion.SaveConverterLegacyTo19132;
 
 import java.util.ArrayList;
@@ -18,5 +19,6 @@ public class SaveConverters
         saveConverters.add(new SaveConverterLegacyTo19132());
         saveConverters.add(new SaveConverter19132To19133());
         saveConverters.add(new SaveConverter19133To19134());
+        saveConverters.add(new SaveConverter19134To19135());
     }
 }
diff --git a/game/core/src/main/java/net/minecraft/core/world/save/SaveFormats.java b/game/core/src/main/java/net/minecraft/core/world/save/SaveFormats.java
index 7d219878b..4abda32e3 100644
--- a/game/core/src/main/java/net/minecraft/core/world/save/SaveFormats.java
+++ b/game/core/src/main/java/net/minecraft/core/world/save/SaveFormats.java
@@ -7,6 +7,7 @@ import net.minecraft.core.world.save.legacy.SaveFormatLegacy;
 import net.minecraft.core.world.save.mcregion.SaveFormat19132;
 import net.minecraft.core.world.save.mcregion.SaveFormat19133;
 import net.minecraft.core.world.save.mcregion.SaveFormat19134;
+import net.minecraft.core.world.save.mcregion.SaveFormat19135;
 import org.slf4j.Logger;
 
 import java.io.File;
@@ -35,5 +36,6 @@ public class SaveFormats
         saveFormats.put(19132, SaveFormat19132.class);
         saveFormats.put(19133, SaveFormat19133.class);
         saveFormats.put(19134, SaveFormat19134.class);
+        saveFormats.put(19135, SaveFormat19135.class);
     }
 }
diff --git a/game/core/src/main/java/net/minecraft/core/world/save/conversion/SaveConverter19132To19133.java b/game/core/src/main/java/net/minecraft/core/world/save/conversion/SaveConverter19132To19133.java
index d2c56cabd..abaa50516 100644
--- a/game/core/src/main/java/net/minecraft/core/world/save/conversion/SaveConverter19132To19133.java
+++ b/game/core/src/main/java/net/minecraft/core/world/save/conversion/SaveConverter19132To19133.java
@@ -7,6 +7,7 @@ import net.minecraft.core.world.Dimension;
 import net.minecraft.core.world.ProgressListener;
 import net.minecraft.core.world.save.mcregion.RegionFile;
 import net.minecraft.core.world.save.mcregion.RegionFileCache;
+import org.jetbrains.annotations.NotNull;
 import org.slf4j.Logger;
 
 import java.io.DataInputStream;
@@ -33,7 +34,7 @@ public class SaveConverter19132To19133
     }
 
     @Override
-    int convertDimensionRegions(Dimension dimension, ArrayList<File> regionFiles, int conversionsPerformed, int totalConversions, ProgressListener progress)
+    int convertDimensionRegions(@NotNull Dimension dimension, @NotNull ArrayList<File> regionFiles, int conversionsPerformed, int totalConversions, @NotNull ProgressListener progress)
     {
         Collections.sort(regionFiles);
         int progressValue = 0;
diff --git a/game/core/src/main/java/net/minecraft/core/world/save/conversion/SaveConverter19133To19134.java b/game/core/src/main/java/net/minecraft/core/world/save/conversion/SaveConverter19133To19134.java
index 297412ccc..840fa045c 100644
--- a/game/core/src/main/java/net/minecraft/core/world/save/conversion/SaveConverter19133To19134.java
+++ b/game/core/src/main/java/net/minecraft/core/world/save/conversion/SaveConverter19133To19134.java
@@ -2,11 +2,9 @@ package net.minecraft.core.world.save.conversion;
 
 import com.mojang.logging.LogUtils;
 import com.mojang.nbt.tags.CompoundTag;
-import net.minecraft.core.data.legacy.LegacyWorldTypes;
 import net.minecraft.core.data.registry.Registries;
 import net.minecraft.core.world.Dimension;
 import net.minecraft.core.world.ProgressListener;
-import net.minecraft.core.world.World;
 import net.minecraft.core.world.save.DimensionData;
 import net.minecraft.core.world.save.ISaveFormat;
 import net.minecraft.core.world.save.SaveFormats;
@@ -40,7 +38,7 @@ public class SaveConverter19133To19134
     }
 
     @Override
-    public void convertSave(CompoundTag levelData, File savesDir, String worldDirName, ProgressListener progress)
+    public void convertSave(@NotNull CompoundTag levelData, @NotNull File savesDir, @NotNull String worldDirName, @NotNull ProgressListener progress)
     {
         this.savesDir = savesDir;
         this.worldDirName = worldDirName;
@@ -138,7 +136,7 @@ public class SaveConverter19133To19134
     }
 
     @Override
-    int convertDimensionRegions(Dimension dimension, ArrayList<File> regionFiles, int conversionsPerformed, int totalConversions, ProgressListener progress)
+    int convertDimensionRegions(@NotNull Dimension dimension, @NotNull ArrayList<File> regionFiles, int conversionsPerformed, int totalConversions, @NotNull ProgressListener progress)
     {
         return 0;
     }
diff --git a/game/core/src/main/java/net/minecraft/core/world/save/conversion/SaveConverter19134To19135.java b/game/core/src/main/java/net/minecraft/core/world/save/conversion/SaveConverter19134To19135.java
new file mode 100644
index 000000000..6ef88d731
--- /dev/null
+++ b/game/core/src/main/java/net/minecraft/core/world/save/conversion/SaveConverter19134To19135.java
@@ -0,0 +1,209 @@
+package net.minecraft.core.world.save.conversion;
+
+import com.mojang.logging.LogUtils;
+import com.mojang.nbt.NbtIo;
+import com.mojang.nbt.tags.CompoundTag;
+import com.mojang.nbt.tags.DoubleTag;
+import com.mojang.nbt.tags.ListTag;
+import com.mojang.nbt.tags.Tag;
+import net.minecraft.core.world.Dimension;
+import net.minecraft.core.world.ProgressListener;
+import net.minecraft.core.world.save.mcregion.RegionFile;
+import org.jetbrains.annotations.NotNull;
+import org.jetbrains.annotations.Nullable;
+import org.slf4j.Logger;
+
+import java.io.DataInputStream;
+import java.io.DataOutputStream;
+import java.io.File;
+import java.io.IOException;
+import java.util.ArrayList;
+import java.util.Arrays;
+import java.util.Random;
+
+public class SaveConverter19134To19135 extends SaveConverterMCRegionBase{
+    private static final Logger LOGGER = LogUtils.getLogger();
+
+    private final int oldMinY = 128;
+    private final int newMinY = 64;
+    private final int shift = this.oldMinY - this.newMinY;
+    private final @NotNull Random random = new Random();
+
+    @Override
+    int convertDimensionRegions(@NotNull Dimension dimension, @NotNull ArrayList<File> regionFiles, int conversionsPerformed, int totalConversions, @NotNull ProgressListener progress) {
+        if (dimension == Dimension.NETHER) {
+            for (int ri = 0, regionFilesSize = regionFiles.size(); ri < regionFilesSize; ri++) {
+                File region = regionFiles.get(ri);
+                RegionFile regionFile = new RegionFile(region);
+
+                for (int rx = 0; rx < 32; rx++) {
+                    for (int rz = 0; rz < 32; rz++) {
+                        try
+                        {
+                            DataOutputStream outputStream = regionFile.getChunkDataOutputStream(rx, rz);
+                            DataInputStream inputStream = regionFile.getChunkDataInputStream(rx, rz);
+                            if (inputStream == null) continue;
+                            CompoundTag chunkData = NbtIo.read(inputStream);
+
+                            // Shift sections down to match new min y
+                            ListTag sections = chunkData.getCompound("Level").getList("Sections");
+                            boolean shift = true;
+//                            for (final @NotNull Tag<?> tag : sections) {
+//                                if (tag instanceof CompoundTag compoundTag) {
+//                                    int section = compoundTag.getInteger("yPos");
+//                                    if (section < 8) {
+//                                        if (compoundTag.containsKey("Data")) {
+//                                            shift = false;
+//                                        }
+//                                    }
+//                                }
+//                            }
+
+                            // Hacky way to not shift existing nightly chunks
+                            if (chunkData.getCompound("Level").containsKey("TicksList")) {
+                                shift = false;
+                            }
+
+                            if (shift) {
+                                ListTag shiftedSections = new ListTag();
+                                for (final @NotNull Tag<?> tag : sections) {
+                                    if (tag instanceof CompoundTag compoundTag) {
+                                        var converted = convertSection(compoundTag);
+                                        if (converted != null) {
+                                            shiftedSections.addTag(converted);
+                                        }
+                                    }
+                                }
+
+                                // Fill now empty section above the old nether with new sections
+                                final short bedrock = 260;
+                                final short netherrack = 800;
+                                byte[] defaultBiomeMap = new byte[512];
+                                short[] defaultBlocksNetherrack = new short[16 * 16 * 16];
+                                short[] defaultBlocksBedrock = new short[16 * 16 * 16];
+                                Arrays.fill(defaultBlocksNetherrack, netherrack);
+                                Arrays.fill(defaultBlocksBedrock, bedrock);
+                                for (int i = (15 - (this.shift / 16)); i < 16; i++) {
+                                    CompoundTag newSection = new CompoundTag();
+                                    newSection.putInt("yPos", i);
+                                    newSection.putByteArray("BiomeMap", defaultBiomeMap);
+                                    if (i == 15) { // New bedrock ceiling
+                                        short[] newBlocks = new short[16 * 16 * 16];
+                                        Arrays.fill(newBlocks, 0, 16 * 16 * (15 - 10), netherrack);
+                                        for (int _y = (15 - 10); _y < 16; _y++) {
+                                            for (int _x = 0; _x < 16; _x++) {
+                                                for (int _z = 0; _z < 16; _z++) {
+                                                    newBlocks[_y * 16 * 16 + _z * 16 + _x] = _y >= 15 - this.random.nextInt(10) ? bedrock : netherrack;
+                                                }
+                                            }
+                                        }
+                                        newSection.putShortArray("Blocks", newBlocks);
+                                    } else {
+                                        newSection.putShortArray("Blocks", defaultBlocksNetherrack);
+                                    }
+                                    shiftedSections.addTag(newSection);
+                                }
+                                // fill empty sections below the nether with bedrock
+                                for (int i = 0; i < 4; i++) {
+                                    CompoundTag newSection = new CompoundTag();
+                                    newSection.putInt("yPos", i);
+                                    newSection.putByteArray("BiomeMap", defaultBiomeMap);
+                                    newSection.putShortArray("Blocks", defaultBlocksBedrock);
+                                    shiftedSections.addTag(newSection);
+                                }
+
+                                chunkData.getCompound("Level").putList("Sections", shiftedSections);
+
+                                // Shift entities
+                                ListTag entities = chunkData.getCompound("Level").getList("Entities");
+                                for (final @NotNull Tag<?> tag : entities) {
+                                    if (tag instanceof CompoundTag entityTag) {
+                                        convertEntity(entityTag);
+                                    }
+                                }
+
+                                // Shift tile entities
+                                ListTag tileEntities = chunkData.getCompound("Level").getList("TileEntities");
+                                for (final @NotNull Tag<?> tag : tileEntities) {
+                                    if (tag instanceof CompoundTag tileTag) {
+                                        convertTileEntity(tileTag);
+                                    }
+                                }
+                            }
+
+                            // Write level data
+                            NbtIo.write(chunkData, outputStream);
+
+                            // Close streams
+                            inputStream.close();
+                            outputStream.close();
+                        }
+                        catch(IOException e)
+                        {
+                            LOGGER.error("Failed to convert chunk X:{}, Z:{}, in region {}!", rx, rz, region.toPath(), e);
+                        }
+                    }
+                }
+            }
+        }
+        return 0;
+    }
+
+    private @Nullable CompoundTag convertSection(@NotNull CompoundTag oldSection) {
+        int section = oldSection.getInteger("yPos");
+        if (section == 15) { // Replace bedrock ceiling
+            if (oldSection.containsKey("Blocks")) {
+                short[] blocks = oldSection.getShortArray("Blocks");
+                final int bedrock = 260;
+                final int netherrack = 800;
+                for (int i = 0; i < blocks.length; i++) {
+                    short blockId = blocks[i];
+                    if (blockId == bedrock) {
+                        blocks[i] = netherrack;
+                    }
+                }
+                oldSection.putShortArray("Blocks", blocks);
+            }
+
+        }
+        section -= (this.shift / 16);
+        if (section >= 4) {
+            oldSection.putInt("yPos", section);
+            return oldSection;
+        }
+        return null;
+    }
+
+    private void convertEntity(@NotNull CompoundTag entityTag) {
+        ListTag pos = entityTag.getList("Pos");
+        double x = ((DoubleTag)pos.tagAt(0)).getValue();
+        double y = ((DoubleTag)pos.tagAt(1)).getValue() - this.shift;
+        double z = ((DoubleTag)pos.tagAt(2)).getValue();
+        ListTag newPos = new ListTag();
+        newPos.addTag(new DoubleTag(x));
+        newPos.addTag(new DoubleTag(y));
+        newPos.addTag(new DoubleTag(z));
+        entityTag.putList("Pos", newPos);
+
+        // Handle entity specific conversions
+        String entityId = entityTag.getString("id");
+        switch (entityId) {
+            case "minecraft:painting" -> entityTag.putInt("TileY", entityTag.getInteger("TileY") - this.shift);
+            case "minecraft:arrow", "minecraft:arrow_golden", "minecraft:arrow_purple" -> entityTag.putInt("yTile", entityTag.getInteger("yTile") - this.shift);
+        }
+    }
+
+    private void convertTileEntity(@NotNull CompoundTag tileEntityTag) {
+        tileEntityTag.putInt("y", tileEntityTag.getInteger("y") - this.shift);
+    }
+
+    @Override
+    public int fromVersion() {
+        return 19134;
+    }
+
+    @Override
+    public int toVersion() {
+        return 19135;
+    }
+}
diff --git a/game/core/src/main/java/net/minecraft/core/world/save/conversion/SaveConverterLegacyTo19132.java b/game/core/src/main/java/net/minecraft/core/world/save/conversion/SaveConverterLegacyTo19132.java
index 11b7f86fd..a46029874 100644
--- a/game/core/src/main/java/net/minecraft/core/world/save/conversion/SaveConverterLegacyTo19132.java
+++ b/game/core/src/main/java/net/minecraft/core/world/save/conversion/SaveConverterLegacyTo19132.java
@@ -12,6 +12,7 @@ import net.minecraft.core.world.save.legacy.ChunkFilePattern;
 import net.minecraft.core.world.save.legacy.ChunkFolderPattern;
 import net.minecraft.core.world.save.mcregion.RegionFile;
 import net.minecraft.core.world.save.mcregion.RegionFileCache;
+import org.jetbrains.annotations.NotNull;
 import org.slf4j.Logger;
 
 import java.io.*;
@@ -39,7 +40,7 @@ public class SaveConverterLegacyTo19132
     }
 
     @Override
-    public void convertSave(CompoundTag tag, File savesDir, String saveDirName, ProgressListener progress)
+    public void convertSave(@NotNull CompoundTag tag, @NotNull File savesDir, @NotNull String saveDirName, @NotNull ProgressListener progress)
     {
         // Get directories for each dimension's data
         File dim0dir = new File(savesDir, saveDirName);
diff --git a/game/core/src/main/java/net/minecraft/core/world/save/conversion/SaveConverterMCRegionBase.java b/game/core/src/main/java/net/minecraft/core/world/save/conversion/SaveConverterMCRegionBase.java
index 37f5bae97..2ca2f14ad 100644
--- a/game/core/src/main/java/net/minecraft/core/world/save/conversion/SaveConverterMCRegionBase.java
+++ b/game/core/src/main/java/net/minecraft/core/world/save/conversion/SaveConverterMCRegionBase.java
@@ -6,6 +6,7 @@ import net.minecraft.core.world.ProgressListener;
 import net.minecraft.core.world.save.ISaveConverter;
 import net.minecraft.core.world.save.ISaveFormat;
 import net.minecraft.core.world.save.SaveFormats;
+import org.jetbrains.annotations.NotNull;
 
 
 import java.io.File;
@@ -18,7 +19,7 @@ public abstract class SaveConverterMCRegionBase
     String worldDirName;
 
     @Override
-    public void convertSave(CompoundTag levelData, File savesDir, String worldDirName, ProgressListener progress)
+    public void convertSave(@NotNull CompoundTag levelData, @NotNull File savesDir, @NotNull String worldDirName, @NotNull ProgressListener progress)
     {
         this.savesDir = savesDir;
         this.worldDirName = worldDirName;
@@ -63,7 +64,7 @@ public abstract class SaveConverterMCRegionBase
         }
     }
 
-    abstract int convertDimensionRegions(Dimension dimension, ArrayList<File> regionFiles, int conversionsPerformed, int totalConversions, ProgressListener progress);
+    abstract int convertDimensionRegions(@NotNull Dimension dimension, @NotNull ArrayList<File> regionFiles, int conversionsPerformed, int totalConversions, @NotNull ProgressListener progress);
 
     ArrayList<File> getRegionFiles(File dimensionDir)
     {
